/* Tabela EFETCLIE: Efetivos */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela EFETCLIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela EFETCLIE,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_EFETCLIE
AFTER DELETE OR INSERT OR UPDATE
ON EFETCLIE FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN
      V_DESC := 'Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC  || ' Serv=' || :OLD.CDSERVFILI;
      V_DESC := V_DESC  || ' Clie=' || :OLD.CDCLIENTE;
      V_DESC := V_DESC  || ' Data=' || TO_CHAR(:OLD.DTEFETCLIE, 'DD/MM/YYYY');
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL || :OLD.CDSERVFILI || :OLD.CDCLIENTE || TO_CHAR(:OLD.DTEFETCLIE, 'YYYYMMDD');
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL  ) OR
            (:OLD.CDSERVFILI <> :NEW.CDSERVFILI) OR
            (:OLD.CDCLIENTE  <> :NEW.CDCLIENTE ) OR
            (:OLD.DTEFETCLIE <> :NEW.DTEFETCLIE) OR
            (NVL(:OLD.CDFILIFATU,   '') <> NVL(:NEW.CDFILIFATU,   '')) OR
            (NVL(:OLD.NRAPURACFAT,  '') <> NVL(:NEW.NRAPURACFAT,  '')) OR
            (NVL(:OLD.QTCOMEFETCLI,  -1) <> NVL(:NEW.QTCOMEFETCLI,  -1)) OR
            (NVL(:OLD.QTDOAEFETCLI,  -1) <> NVL(:NEW.QTDOAEFETCLI,  -1)) OR
            (NVL(:OLD.QTFUNEFETCLI,  -1) <> NVL(:NEW.QTFUNEFETCLI,  -1)) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || :OLD.CDSERVFILI || :OLD.CDCLIENTE || TO_CHAR(:OLD.DTEFETCLIE, 'YYYYMMDD');
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || :NEW.CDSERVFILI || :NEW.CDCLIENTE || TO_CHAR(:NEW.DTEFETCLIE, 'YYYYMMDD');
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDSERVFILI <> :NEW.CDSERVFILI) THEN
            V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI || '|' || :NEW.CDSERVFILI;
         ELSE
            V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Serv=' || :NEW.CDSERVFILI;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDCLIENTE <> :NEW.CDCLIENTE) THEN
            V_DESC := V_DESC || ' Clie=' || :OLD.CDCLIENTE || '|' || :NEW.CDCLIENTE;
         ELSE
            V_DESC := V_DESC || ' Clie=' || :OLD.CDCLIENTE;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Clie=' || :NEW.CDCLIENTE;
      END IF;
      IF UPDATING THEN
         IF (:OLD.DTEFETCLIE <> :NEW.DTEFETCLIE) THEN
            V_DESC := V_DESC || ' Data=' || TO_CHAR(:OLD.DTEFETCLIE, 'DD/MM/YYYY') || '|' || TO_CHAR(:NEW.DTEFETCLIE, 'DD/MM/YYYY');
         ELSE
            V_DESC := V_DESC || ' Data=' || TO_CHAR(:OLD.DTEFETCLIE, 'DD/MM/YYYY');
         END IF;
      ELSE
         V_DESC := V_DESC || ' Data=' || TO_CHAR(:NEW.DTEFETCLIE, 'DD/MM/YYYY');
      END IF;
      IF (NVL(:NEW.QTCOMEFETCLI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCOMEFETCLI, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCOMEFETCLI, -1) <> NVL(:NEW.QTCOMEFETCLI, -1)) THEN
               V_DESC := V_DESC || ' Clientes=' || :OLD.QTCOMEFETCLI || '|' || :NEW.QTCOMEFETCLI;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Clientes=' || :NEW.QTCOMEFETCLI;
         END IF;
      END IF;
      IF (NVL(:NEW.QTFUNEFETCLI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTFUNEFETCLI, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTFUNEFETCLI, -1) <> NVL(:NEW.QTFUNEFETCLI, -1)) THEN
               V_DESC := V_DESC || ' Funcionrios=' || :OLD.QTFUNEFETCLI || '|' || :NEW.QTFUNEFETCLI;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Funcionrios=' || :NEW.QTFUNEFETCLI;
         END IF;
      END IF;
      IF (NVL(:NEW.QTDOAEFETCLI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTDOAEFETCLI, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTDOAEFETCLI, -1) <> NVL(:NEW.QTDOAEFETCLI, -1)) THEN
               V_DESC := V_DESC || ' Doaes=' || :OLD.QTDOAEFETCLI || '|' || :NEW.QTDOAEFETCLI;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Doaes=' || :NEW.QTDOAEFETCLI;
         END IF;
      END IF;
      IF (NVL(:NEW.CDFILIFATU, '') <> '') OR (UPDATING AND (NVL(:NEW.CDFILIFATU, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDFILIFATU, '') <> NVL(:NEW.CDFILIFATU, '')) THEN
               V_DESC := V_DESC || ' FiliFatu=' || :OLD.CDFILIFATU || '|' || :NEW.CDFILIFATU;
            END IF;
         ELSE
            V_DESC := V_DESC || ' FiliFatu=' || :NEW.CDFILIFATU;
         END IF;
      END IF;
      IF (NVL(:NEW.NRAPURACFAT, '') <> '') OR (UPDATING AND (NVL(:NEW.NRAPURACFAT, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRAPURACFAT, '') <> NVL(:NEW.NRAPURACFAT, '')) THEN
               V_DESC := V_DESC || ' NrApurac=' || :OLD.NRAPURACFAT || '|' || :NEW.NRAPURACFAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' NrApurac=' || :NEW.NRAPURACFAT;
         END IF;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            WEBTUNNING(V_DSIP, V_DSUSUARIO, V_DSRDM, V_DSMETODO, V_DSOPERADOR);
            V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
            V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
            V_DESC := V_DESC || ' Ip='       || V_DSIP;
            V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
            V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
            INSERT INTO LOGOPERA
               (NMTABELA, DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('EFETCLIE', SYSDATE, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_EFETCLIE','4.05.071'); END;
/

