<?php
namespace Teknisa\Model\Teknisa\Repositories;


use Zeedhi\DevOps\Util\Utilities;
use Doctrine\DBAL\Connection;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class EmailAdicionais extends \Doctrine\ORM\EntityRepository {
    
    public function findEmailsAdicionais($conditions, $limit, $offset){
        $query = <<<SQL
        SELECT E.*
            FROM EMAILADICIONAIS E
            LEFT JOIN FILIAL FI ON E.CDFILIAL = FI.CDFILIAL
            LEFT JOIN CLIENTE C ON E.CDCLIENTE = C.CDCLIENTE
            LEFT JOIN FORNECEDOR FO ON E.CDFORNECED = FO.CDFORNECED
            LEFT JOIN TRANSPORT T ON (E.IDTPIJURTRAN = T.IDTPIJURTRAN AND E.NRINSJURTRAN = T.NRINSJURTRAN)
        WHERE 1=1
        $conditions
SQL;

        $query  = $this->getPaginatedQuery($query, $limit, $offset);
        $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        return ($result) ? $result : [];
    }
    
    public function findTransportadoras($conditions, $limit, $offset){
        $query = <<<SQL
        SELECT *
          FROM TRANSPORT
SQL;

        $query  = $this->getPaginatedQuery($query, $limit, $offset);
        $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        return ($result) ? $result : [];
    }
    
    public function adicionarEmail($emailRow, $cdOperador, $nrorg, $date, $idAtivo = 'S'){
        $novoCodigo = NovoCodigo::geraCodigo($nrorg, "EmailAdicionais", 1, 10, false, false);
        $sql = <<<SQL
        INSERT INTO EMAILADICIONAIS
        VALUES (
            :IDORIGEM,
            :IDEMAIL,
            :CDCLIENTE,
            :CDFORNECED,
            :CDFILIAL,
            :IDTPIJURTRAN,
            :NRINSJURTRAN,
            :DSEMAIL,
            :NRORG,
            :IDATIVO,
            :DTINCLUSAO,
            :NRORGINCLUSAO,
            :CDOPERINCLUSAO,
            :DTULTATU,
            :NRORGULTATU,
            :CDOPERULTATU
        )
SQL;

    $params = array(    "IDORIGEM"	        => $emailRow['IDORIGEM'],
		                "IDEMAIL"           => $novoCodigo,
		                "CDCLIENTE"         => $emailRow['CDCLIENTE'],
		                "CDFORNECED"        => $emailRow['CDFORNECED'],
		                "CDFILIAL"          => $emailRow['CDFILIAL'],
		                "IDTPIJURTRAN"      => $emailRow['IDTPIJURTRAN'],
		                "NRINSJURTRAN"      => $emailRow['NRINSJURTRAN'],
		                "DSEMAIL"           => $emailRow['DSEMAIL'],
		                "NRORG"             => $nrorg,
		                "IDATIVO"           => $idAtivo,
		                "DTINCLUSAO"        => $date,
		                "NRORGINCLUSAO"     => $nrorg,
		                "CDOPERINCLUSAO"    => $cdOperador,
		                "DTULTATU"          => $date,
		                "NRORGULTATU"       => $nrorg,
		                "CDOPERULTATU"      => $cdOperador,
		                );
    
    $std = $this->getEntityManager()->getConnection()->prepare($sql);
    return $std->execute($params);
    }
    
    public function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $limit . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $limit;
            }
        }
        return $query;
    }
}
